=== debian/changelog ===
diamond-aligner (2.0.14-1) unstable; urgency=medium

  * New upstream version
  * Add missing build dependency on dh addon.

 -- Andreas Tille <tille@debian.org>  Sun, 16 Jan 2022 16:20:52 +0100

diamond-aligner (2.0.13-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 2.0.13
  * Update manpage

 -- Nilesh Patra <nilesh@debian.org>  Sun, 31 Oct 2021 15:04:59 +0530

diamond-aligner (2.0.12-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 06 Oct 2021 15:45:53 +0200

diamond-aligner (2.0.11-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Fix watchfile to detect new versions on github (routine-update)
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

  [ Michael R. Crusoe ]
  * Autopkgtest: pass "--ignore-warnings" when needed due to a protein sequence
    that looks like a DNA sequence

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 14 Sep 2021 12:20:33 +0200
