=== debian/control ===
Source: diamond-aligner
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               zlib1g-dev,
               debhelper
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
Homepage: https://github.com/bbuchfink/diamond
Rules-Requires-Root: no

Package: diamond-aligner
Architecture: any-amd64 arm64 ppc64el s390x ia64 ppc64 riscv64 sparc64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config
Breaks: diamond
Replaces: diamond
Description: accelerated BLAST compatible local sequence aligner
 DIAMOND is a sequence aligner for protein and translated DNA searches
 and functions as a drop-in replacement for the NCBI BLAST software
 tools. It is suitable for protein-protein search as well as DNA-protein
 search on short reads and longer sequences including contigs and
 assemblies, providing a speedup of BLAST ranging up to x20,000.
