## diamond-aligner 2.0.15

=== debian/changelog ===
diamond-aligner (2.0.15-1) unstable; urgency=medium

  * Create sensible upstream tarball name when using uscan
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 02 May 2022 12:17:22 +0200
