=== debian/changelog ===
diamond-aligner (2.1.1-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version. Closes: #1030360

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 20 Feb 2023 13:03:15 +0100

diamond-aligner (2.1.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 01 Feb 2023 16:54:35 +0100
