## diamond-aligner 2.1.3

=== debian/changelog ===
diamond-aligner (2.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version. Finally fixes the arm64 build.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 23 Feb 2023 17:31:41 +0100

diamond-aligner (2.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 20 Feb 2023 14:07:27 +0100
