=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                cmake,
                zlib1g-dev,
                debhelper
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
 Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond
