=== debian/changelog ===
diamond-aligner (2.1.8-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 11 Jul 2023 17:22:50 +0200
