=== debian/control ===
--- 
+++ 
@@ -18,8 +18,6 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Recommends: med-config
-Breaks: diamond
-Replaces: diamond
 Description: accelerated BLAST compatible local sequence aligner
  DIAMOND is a sequence aligner for protein and translated DNA searches
  and functions as a drop-in replacement for the NCBI BLAST software
